/*****************************************************************************
 * Copyright (c) 2013 CEA LIST.
 *
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *  Vincent Lorenzo (CEA LIST) vincent.lorenzo@cea.fr - Initial API and implementation
 *
 *****************************************************************************/
package org.eclipse.papyrus.uml.tools.utils;


public class PrimitivesTypesUtils {

	private PrimitivesTypesUtils() {
		// to prevent instanciation
	}

	/** the string used for the uml boolean */
	public static final String UML_BOOLEAN = "Boolean";//$NON-NLS-1$

	/** the string used for UML integer */
	public static final String UML_INTEGER = "Integer"; //$NON-NLS-1$

	/** the string used for uml real */
	public static final String UML_REAL = "Real"; //$NON-NLS-1$

	/** the string used for UML string */
	public static final String UML_STRING = "String"; //$NON-NLS-1$

	/** the string used for uml unlimited natural */
	public static final String UML_UNLIMITED_NATURAL = "UnlimitedNatural"; //$NON-NLS-1$

	/** the string used for enumeration */
	public static final String ENUMERATION = "Enumeration"; //$NON-NLS-1$

	/** the string used for enumeration literal */
	public static final String ENUMERATION_LITERAL = "EnumerationLiteral"; //$NON-NLS-1$


}
